diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac-queue.h ns-3.31/src/wifi/model/wifi-mac-queue.h
--- ns-3.30.1/src/wifi/model/wifi-mac-queue.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac-queue.h	2020-06-27 17:38:30.000000000 -0700
@@ -34,7 +34,7 @@
 // The following explicit template instantiation declaration prevents modules
 // including this header file from implicitly instantiating Queue<WifiMacQueueItem>.
 // This would cause python examples using wifi to crash at runtime with the
-// following error message: "Trying to allocate twice the same uid:
+// following error message: "Trying to allocate twice the same UID:
 // ns3::Queue<WifiMacQueueItem>"
 extern template class Queue<WifiMacQueueItem>;
 
@@ -79,18 +79,6 @@
   using Queue<WifiMacQueueItem>::end;
 
   /**
-   * \brief Set the maximum size of this queue
-   *
-   * Trying to set a null size has no effect.
-   *
-   * \param size the maximum size
-   */
-  void SetMaxQueueSize (QueueSize size);
-  /**
-   * \return the maximum size of this queue
-   */
-  QueueSize GetMaxQueueSize (void) const;
-  /**
    * Set the maximum delay before the packet is discarded.
    *
    * \param delay the maximum delay
@@ -144,17 +132,17 @@
   Ptr<WifiMacQueueItem> DequeueByAddress (Mac48Address dest);
   /**
    * Search and return, if present in the queue, the first packet having the
-   * tid equal to <i>tid</i>.
+   * TID equal to <i>tid</i>.
    * This method removes the packet from the queue.
    *
-   * \param tid the given tid
+   * \param tid the given TID
    *
    * \return the packet
    */
   Ptr<WifiMacQueueItem> DequeueByTid (uint8_t tid);
   /**
    * Search and return, if present in the queue, the first packet having the
-   * address indicated by <i>type</i> equal to <i>addr</i>, and tid
+   * address indicated by <i>type</i> equal to <i>addr</i>, and TID
    * equal to <i>tid</i>. This method removes the packet from the queue.
    * It is typically used by ns3::QosTxop in order to perform correct MSDU
    * aggregation (A-MSDU).
@@ -168,14 +156,14 @@
                                                 Mac48Address dest);
   /**
    * Return first available packet for transmission. A packet could be no available
-   * if it is a QoS packet with a tid and an address1 fields equal to <i>tid</i> and <i>addr</i>
+   * if it is a QoS packet with a TID and an address1 fields equal to <i>tid</i> and <i>addr</i>
    * respectively that index a pending agreement in the BlockAckManager object.
    * So that packet must not be transmitted until reception of an ADDBA response frame from station
    * addressed by <i>addr</i>. This method removes the packet from queue.
    *
-   * \param blockedPackets
+   * \param blockedPackets the destination address & TID pairs that are waiting for a BlockAck response
    *
-   * \return packet
+   * \return the packet
    */
   Ptr<WifiMacQueueItem> DequeueFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets = nullptr);
   /**
@@ -208,7 +196,7 @@
   ConstIterator PeekByAddress (Mac48Address dest, ConstIterator pos = EMPTY) const;
   /**
    * Search and return, if present in the queue, the first packet having the
-   * tid equal to <i>tid</i>. If <i>pos</i> is a valid iterator, the search starts
+   * TID equal to <i>tid</i>. If <i>pos</i> is a valid iterator, the search starts
    * from the packet pointed to by the given iterator.
    * This method does not remove the packet from the queue.
    *
@@ -220,7 +208,7 @@
   ConstIterator PeekByTid (uint8_t tid, ConstIterator pos = EMPTY) const;
   /**
    * Search and return, if present in the queue, the first packet having the
-   * receiver address equal to <i>dest</i>, and tid equal to <i>tid</i>.
+   * receiver address equal to <i>dest</i>, and TID equal to <i>tid</i>.
    * If <i>pos</i> is a valid iterator, the search starts from the packet pointed
    * to by the given iterator. This method does not remove the packet from the queue.
    * It is typically used by ns3::QosTxop in order to perform correct MSDU aggregation
@@ -236,7 +224,7 @@
   /**
    * Return first available packet for transmission. The packet is not removed from queue.
    *
-   * \param blockedPackets
+   * \param blockedPackets the destination address & TID pairs that are waiting for a BlockAck response
    * \param pos the iterator pointing to the packet the search starts from
    *
    * \return an iterator pointing to the peeked packet
@@ -280,7 +268,7 @@
    */
   uint32_t GetNPacketsByAddress (Mac48Address dest);
   /**
-   * Return the number of QoS packets having tid equal to <i>tid</i> and
+   * Return the number of QoS packets having TID equal to <i>tid</i> and
    * destination address equal to <i>dest</i>.
    *
    * \param tid the given TID
@@ -313,6 +301,7 @@
 
   static const ConstIterator EMPTY;         //!< Invalid iterator to signal an empty queue
 
+
 private:
   /**
    * Remove the item pointed to by the iterator <i>it</i> if it has been in the
@@ -324,10 +313,9 @@
    */
   bool TtlExceeded (ConstIterator &it);
 
-  QueueSize m_maxSize;                      //!< max queue size
   Time m_maxDelay;                          //!< Time to live for packets in the queue
   DropPolicy m_dropPolicy;                  //!< Drop behavior of queue
-  mutable bool m_expiredPacketsPresent;     //!> True if expired packets are in the queue
+  mutable bool m_expiredPacketsPresent;     //!< True if expired packets are in the queue
 
   /// Traced callback: fired when a packet is dropped due to lifetime expiration
   TracedCallback<Ptr<const WifiMacQueueItem> > m_traceExpired;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac-queue-item.cc ns-3.31/src/wifi/model/wifi-mac-queue-item.cc
--- ns-3.30.1/src/wifi/model/wifi-mac-queue-item.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac-queue-item.cc	2020-06-27 17:38:30.000000000 -0700
@@ -26,6 +26,7 @@
 #include "ns3/log.h"
 #include "wifi-mac-queue-item.h"
 #include "wifi-mac-trailer.h"
+#include "wifi-utils.h"
 
 namespace ns3 {
 
@@ -41,6 +42,10 @@
     m_header (header),
     m_tstamp (tstamp)
 {
+  if (header.IsQosData () && header.IsQosAmsdu ())
+    {
+      m_msduList = MsduAggregator::Deaggregate (p->Copy ());
+    }
 }
 
 WifiMacQueueItem::~WifiMacQueueItem ()
@@ -83,6 +88,117 @@
   return m_packet->GetSize () + m_header.GetSerializedSize () + WIFI_MAC_FCS_LENGTH;
 }
 
+Ptr<Packet>
+WifiMacQueueItem::GetProtocolDataUnit (void) const
+{
+  Ptr<Packet> mpdu = m_packet->Copy ();
+  mpdu->AddHeader (m_header);
+  AddWifiMacTrailer (mpdu);
+  return mpdu;
+}
+
+void
+WifiMacQueueItem::Aggregate (Ptr<const WifiMacQueueItem> msdu)
+{
+  NS_ASSERT (msdu != 0);
+  NS_LOG_FUNCTION (this << *msdu);
+  NS_ABORT_MSG_IF (!msdu->GetHeader ().IsQosData () || msdu->GetHeader ().IsQosAmsdu (),
+                   "Only QoS data frames that do not contain an A-MSDU can be aggregated");
+
+  if (m_msduList.empty ())
+    {
+      // An MSDU is going to be aggregated to this MPDU, hence this has to be an A-MSDU now
+      Ptr<const WifiMacQueueItem> firstMsdu = Create<const WifiMacQueueItem> (*this);
+      m_packet = Create<Packet> ();
+      DoAggregate (firstMsdu);
+
+      m_header.SetQosAmsdu ();
+      // Set Address3 according to Table 9-26 of 802.11-2016
+      if (m_header.IsToDs () && !m_header.IsFromDs ())
+        {
+          // from STA to AP: BSSID is in Address1
+          m_header.SetAddr3 (m_header.GetAddr1 ());
+        }
+      else if (!m_header.IsToDs () && m_header.IsFromDs ())
+        {
+          // from AP to STA: BSSID is in Address2
+          m_header.SetAddr3 (m_header.GetAddr2 ());
+        }
+      // in the WDS case (ToDS = FromDS = 1), both Address 3 and Address 4 need
+      // to be set to the BSSID, but neither Address 1 nor Address 2 contain the
+      // BSSID. Hence, it is left up to the caller to set these Address fields.
+    }
+  DoAggregate (msdu);
+}
+
+void
+WifiMacQueueItem::DoAggregate (Ptr<const WifiMacQueueItem> msdu)
+{
+  NS_LOG_FUNCTION (this << *msdu);
+
+  // build the A-MSDU Subframe header
+  AmsduSubframeHeader hdr;
+  /*
+   * (See Table 9-26 of 802.11-2016)
+   *
+   * ToDS | FromDS |  DA   |  SA
+   *   0  |   0    | Addr1 | Addr2
+   *   0  |   1    | Addr1 | Addr3
+   *   1  |   0    | Addr3 | Addr2
+   *   1  |   1    | Addr3 | Addr4
+   */
+  hdr.SetDestinationAddr (msdu->GetHeader ().IsToDs () ? msdu->GetHeader ().GetAddr3 ()
+                                                       : msdu->GetHeader ().GetAddr1 ());
+  hdr.SetSourceAddr (!msdu->GetHeader ().IsFromDs () ? msdu->GetHeader ().GetAddr2 ()
+                                                     : (!msdu->GetHeader ().IsToDs ()
+                                                        ? msdu->GetHeader ().GetAddr3 ()
+                                                        : msdu->GetHeader ().GetAddr4 ()));
+  hdr.SetLength (static_cast<uint16_t> (msdu->GetPacket ()->GetSize ()));
+
+  m_msduList.push_back ({msdu->GetPacket (), hdr});
+
+  // build the A-MSDU
+  NS_ASSERT (m_packet);
+  Ptr<Packet> amsdu = m_packet->Copy ();
+
+  // pad the previous A-MSDU subframe if the A-MSDU is not empty
+  if (m_packet->GetSize () > 0)
+    {
+      uint8_t padding = MsduAggregator::CalculatePadding (m_packet->GetSize ());
+
+      if (padding)
+        {
+          amsdu->AddAtEnd (Create<Packet> (padding));
+        }
+    }
+
+  // add A-MSDU subframe header and MSDU
+  Ptr<Packet> amsduSubframe = msdu->GetPacket ()->Copy ();
+  amsduSubframe->AddHeader (hdr);
+  amsdu->AddAtEnd (amsduSubframe);
+  m_packet = amsdu;
+
+  /* "The expiration of the A-MSDU lifetime timer occurs only when the lifetime
+    * timer of all of the constituent MSDUs of the A-MSDU have expired" (Section
+    * 10.12 of 802.11-2016)
+    */
+  // The timestamp of the A-MSDU is the most recent among those of the MSDUs
+  m_tstamp = Max (m_tstamp, msdu->GetTimeStamp ());
+}
+
+
+MsduAggregator::DeaggregatedMsdusCI
+WifiMacQueueItem::begin (void)
+{
+  return m_msduList.begin ();
+}
+
+MsduAggregator::DeaggregatedMsdusCI
+WifiMacQueueItem::end (void)
+{
+  return m_msduList.end ();
+}
+
 void
 WifiMacQueueItem::Print (std::ostream& os) const
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac-queue-item.h ns-3.31/src/wifi/model/wifi-mac-queue-item.h
--- ns-3.30.1/src/wifi/model/wifi-mac-queue-item.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac-queue-item.h	2020-06-27 17:38:30.000000000 -0700
@@ -26,6 +26,8 @@
 
 #include "ns3/nstime.h"
 #include "wifi-mac-header.h"
+#include "msdu-aggregator.h"
+#include "amsdu-subframe-header.h"
 
 namespace ns3 {
 
@@ -44,14 +46,14 @@
   /**
    * \brief Create a Wifi MAC queue item containing a packet and a Wifi MAC header.
    * \param p the const packet included in the created item.
-   * \param header the Wifi Mac header included in the created item.
+   * \param header the Wifi MAC header included in the created item.
    */
   WifiMacQueueItem (Ptr<const Packet> p, const WifiMacHeader & header);
 
   /**
    * \brief Create a Wifi MAC queue item containing a packet and a Wifi MAC header.
    * \param p the const packet included in the created item.
-   * \param header the Wifi Mac header included in the created item.
+   * \param header the Wifi MAC header included in the created item.
    * \param tstamp the timestamp associated with the created item.
    */
   WifiMacQueueItem (Ptr<const Packet> p, const WifiMacHeader & header, Time tstamp);
@@ -92,27 +94,65 @@
    * \brief Return the size of the packet stored by this item, including header
    *        size and trailer size
    *
-   * \return the size of the packet stored by this item.
+   * \return the size of the packet stored by this item in bytes.
    */
   uint32_t GetSize (void) const;
 
   /**
+   * \brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
+   *        constituting an A-MSDU). Note that the given MPDU cannot contain
+   *        an A-MSDU.
+   * \param msdu the MPDU containing the MSDU to aggregate
+   */
+  void Aggregate (Ptr<const WifiMacQueueItem> msdu);
+
+  /**
+   * \brief Get a constant iterator pointing to the first MSDU in the list of aggregated MSDUs.
+   *
+   * \return a constant iterator pointing to the first MSDU in the list of aggregated MSDUs
+   */
+  MsduAggregator::DeaggregatedMsdusCI begin (void);
+  /**
+   * \brief Get a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs.
+   *
+   * \return a constant iterator indicating past-the-last MSDU in the list of aggregated MSDUs
+   */
+  MsduAggregator::DeaggregatedMsdusCI end (void);
+
+  /**
+   * \brief Get the MAC protocol data unit (MPDU) corresponding to this item
+   *        (i.e. a copy of the packet stored in this item wrapped with MAC
+   *        header and trailer)
+   * \return the MAC protocol data unit corresponding to this item.
+   */
+  Ptr<Packet> GetProtocolDataUnit (void) const;
+
+  /**
    * \brief Print the item contents.
    * \param os output stream in which the data should be printed.
    */
   virtual void Print (std::ostream &os) const;
 
 private:
-  Ptr<const Packet> m_packet;  //!< The packet contained in this queue item
-  WifiMacHeader m_header;      //!< Wifi MAC header associated with the packet
-  Time m_tstamp;               //!< timestamp when the packet arrived at the queue
+  /**
+   * \brief Aggregate the MSDU contained in the given MPDU to this MPDU (thus
+   *        constituting an A-MSDU). Note that the given MPDU cannot contain
+   *        an A-MSDU.
+   * \param msdu the MPDU containing the MSDU to aggregate
+   */
+  void DoAggregate (Ptr<const WifiMacQueueItem> msdu);
+
+  Ptr<const Packet> m_packet;                   //!< The packet (MSDU or A-MSDU) contained in this queue item
+  WifiMacHeader m_header;                       //!< Wifi MAC header associated with the packet
+  Time m_tstamp;                                //!< timestamp when the packet arrived at the queue
+  MsduAggregator::DeaggregatedMsdus m_msduList; //!< The list of aggregated MSDUs included in this MPDU
 };
 
 /**
  * \brief Stream insertion operator.
  *
- * \param os the stream
- * \param item the item
+ * \param os the output stream
+ * \param item the WifiMacQueueItem
  * \returns a reference to the stream
  */
 std::ostream& operator<< (std::ostream& os, const WifiMacQueueItem &item);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mode.cc ns-3.31/src/wifi/model/wifi-mode.cc
--- ns-3.30.1/src/wifi/model/wifi-mode.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mode.cc	2020-06-27 17:38:30.000000000 -0700
@@ -26,53 +26,22 @@
 
 namespace ns3 {
 
-/**
- * Check if the two WifiModes are identical.
- *
- * \param a WifiMode
- * \param b WifiMode
- *
- * \return true if the two WifiModes are identical,
- *         false otherwise
- */
 bool operator == (const WifiMode &a, const WifiMode &b)
 {
   return a.GetUid () == b.GetUid ();
 }
-/**
- * Compare two WifiModes
- *
- * \param a WifiMode
- * \param b WifiMode
- *
- * \return true if a is less than b,
- *         false otherwise
- */
+
 bool operator < (const WifiMode &a, const WifiMode &b)
 {
   return a.GetUid () < b.GetUid ();
 }
-/**
- * Serialize WifiMode to ostream (human-readable).
- *
- * \param os std::ostream
- * \param mode
- *
- * \return std::ostream
- */
+
 std::ostream & operator << (std::ostream & os, const WifiMode &mode)
 {
   os << mode.GetUniqueName ();
   return os;
 }
-/**
- * Serialize WifiMode from istream (human-readable).
- *
- * \param is std::istream
- * \param mode
- *
- * \return std::istream
- */
+
 std::istream & operator >> (std::istream &is, WifiMode &mode)
 {
   std::string str;
@@ -441,7 +410,7 @@
           return 256;
         case 10:
         case 11:
-          NS_ASSERT (item->modClass == WIFI_MOD_CLASS_HE);
+          NS_ASSERT (item->modClass != WIFI_MOD_CLASS_VHT);
           return 1024;
         default:
           return 0;
@@ -472,7 +441,7 @@
 WifiMode::GetMcsValue (void) const
 {
   WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  if (item->modClass == WIFI_MOD_CLASS_HT || item->modClass == WIFI_MOD_CLASS_VHT || item->modClass == WIFI_MOD_CLASS_HE)
+  if (item->modClass >= WIFI_MOD_CLASS_HT)
     {
       return item->mcsValue;
     }
@@ -502,7 +471,7 @@
 {
   uint64_t dataRate;
   WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  if (item->modClass == WIFI_MOD_CLASS_HT || item->modClass == WIFI_MOD_CLASS_VHT || item->modClass == WIFI_MOD_CLASS_HE)
+  if (item->modClass >= WIFI_MOD_CLASS_HT)
     {
       WifiCodeRate codeRate = GetCodeRate ();
       switch (GetConstellationSize ())
@@ -715,8 +684,8 @@
   item->constellationSize = constellationSize;
   item->isMandatory = isMandatory;
 
-  NS_ASSERT (modClass != WIFI_MOD_CLASS_HT && modClass != WIFI_MOD_CLASS_VHT && modClass != WIFI_MOD_CLASS_HE);
-  //fill unused mcs item with a dummy value
+  NS_ASSERT (modClass < WIFI_MOD_CLASS_HT);
+  //fill unused MCS item with a dummy value
   item->mcsValue = 0;
 
   return WifiMode (uid);
@@ -733,8 +702,7 @@
   item->uniqueUid = uniqueName;
   item->modClass = modClass;
 
-  //The modulation class must be either HT, VHT or HE
-  NS_ASSERT (modClass == WIFI_MOD_CLASS_HT || modClass == WIFI_MOD_CLASS_VHT || modClass == WIFI_MOD_CLASS_HE);
+  NS_ASSERT (modClass >= WIFI_MOD_CLASS_HT);
 
   item->mcsValue = mcsValue;
   //fill unused items with dummy values
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mode.h ns-3.31/src/wifi/model/wifi-mode.h
--- ns-3.30.1/src/wifi/model/wifi-mode.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mode.h	2020-06-27 17:38:30.000000000 -0700
@@ -110,19 +110,19 @@
    * \param guardInterval the considered guard interval duration in nanoseconds
    * \param nss the considered number of streams
    *
-   * \returns the physical bit rate of this signal.
+   * \returns the physical bit rate of this signal in bps.
    *
    * If a transmission mode uses 1/2 FEC, and if its
-   * data rate is 3.25Mbps, the phy rate is 6.5Mbps
+   * data rate is 3.25Mbps, the PHY rate is 6.5Mbps
    */
   uint64_t GetPhyRate (uint16_t channelWidth, uint16_t guardInterval, uint8_t nss) const;
   /**
    * \param txVector the WifiTxVector of the signal
    *
-   * \returns the physical bit rate of this signal.
+   * \returns the physical bit rate of this signal in bps.
    *
    * If a transmission mode uses 1/2 FEC, and if its
-   * data rate is 3.25Mbps, the phy rate is 6.5Mbps
+   * data rate is 3.25Mbps, the PHY rate is 6.5Mbps
    */
   uint64_t GetPhyRate (WifiTxVector txVector) const;
   /**
@@ -131,7 +131,7 @@
    * \param guardInterval the considered guard interval duration in nanoseconds
    * \param nss the considered number of streams
    *
-   * \returns the data bit rate of this signal.
+   * \returns the data bit rate of this signal in bps.
    */
   uint64_t GetDataRate (uint16_t channelWidth, uint16_t guardInterval, uint8_t nss) const;
   /**
@@ -170,11 +170,11 @@
    */
   bool IsMandatory (void) const;
   /**
-   * \returns the uid associated to this wireless mode.
+   * \returns the UID associated to this wireless mode.
    *
-   * Each specific wireless mode should have a different uid.
+   * Each specific wireless mode should have a different UID.
    * For example, the 802.11b 1Mbps and the 802.11b 2Mbps modes
-   * should have different uids.
+   * should have different UIDs.
    */
   uint32_t GetUid (void) const;
   /**
@@ -193,13 +193,13 @@
    */
   uint64_t GetNonHtReferenceRate (void) const;
   /**
-   * \param mode wifi mode
+   * \param mode the WifiMode
    * \returns true if this WifiMode has a
    * a code rate strictly higher than mode.
    */
   bool IsHigherCodeRate (WifiMode mode) const;
   /**
-   * \param mode wifi mode
+   * \param mode the WifiMode
    * \returns true if this WifiMode has a
    * a rate strictly higher than mode.
    */
@@ -224,8 +224,6 @@
 private:
   /// allow WifiModeFactory class access
   friend class WifiModeFactory;
-  /// allow WifiPhyTag class access
-  friend class WifiPhyTag; // access the UID-based constructor
   /**
    * Create a WifiMode from a given unique ID.
    *
@@ -235,10 +233,43 @@
   uint32_t m_uid; ///< UID
 };
 
-/// equality operator
+/**
+ * Check if the two WifiModes are identical.
+ *
+ * \param a WifiMode
+ * \param b WifiMode
+ *
+ * \return true if the two WifiModes are identical,
+ *         false otherwise
+ */
 bool operator == (const WifiMode &a, const WifiMode &b);
+/**
+ * Compare two WifiModes
+ *
+ * \param a WifiMode
+ * \param b WifiMode
+ *
+ * \return true if a is less than b,
+ *         false otherwise
+ */
 bool operator < (const WifiMode &a, const WifiMode &b);
+/**
+ * Serialize WifiMode to ostream (human-readable).
+ *
+ * \param os the output stream
+ * \param mode the WifiMode
+ *
+ * \return std::ostream
+ */
 std::ostream & operator << (std::ostream & os, const WifiMode &mode);
+/**
+ * Serialize WifiMode from istream (human-readable).
+ *
+ * \param is the input stream
+ * \param mode the WifiMode
+ *
+ * \return std::istream
+ */
 std::istream & operator >> (std::istream &is, WifiMode &mode);
 
 ATTRIBUTE_HELPER_HEADER (WifiMode);
@@ -278,7 +309,7 @@
    *
    * \return WifiMode
    *
-   * Create a WifiMode (not used for HT or VHT).
+   * Create a non-HT WifiMode.
    */
   static WifiMode CreateWifiMode (std::string uniqueName,
                                   WifiModulationClass modClass,
@@ -289,12 +320,12 @@
   /**
    * \param uniqueName the name of the associated WifiMode. This name
    *        must be unique across _all_ instances.
-   * \param mcsValue the mcs value
+   * \param mcsValue the MCS value
    * \param modClass the class of modulation
    *
    * \return WifiMode
    *
-   * Create a HT or VHT WifiMode.
+   * Create a HT WifiMode.
    */
   static WifiMode CreateWifiMcs (std::string uniqueName,
                                  uint8_t mcsValue,
@@ -334,23 +365,23 @@
    *
    * \param name human-readable WifiMode
    *
-   * \return WifiMode
+   * \return the WifiMode
    */
   WifiMode Search (std::string name) const;
   /**
    * Allocate a WifiModeItem from a given uniqueUid.
    *
-   * \param uniqueUid
+   * \param uniqueUid the unique UID
    *
-   * \return uid
+   * \return the allocated UID index
    */
   uint32_t AllocateUid (std::string uniqueUid);
   /**
-   * Return a WifiModeItem at the given uid index.
+   * Return a WifiModeItem at the given UID index.
    *
-   * \param uid
+   * \param uid the UID index
    *
-   * \return WifiModeItem at the given uid
+   * \return WifiModeItem at the given UID
    */
   WifiModeItem* Get (uint32_t uid);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mpdu-type.h ns-3.31/src/wifi/model/wifi-mpdu-type.h
--- ns-3.30.1/src/wifi/model/wifi-mpdu-type.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mpdu-type.h	2020-06-27 17:38:30.000000000 -0700
@@ -37,7 +37,7 @@
   FIRST_MPDU_IN_AGGREGATE,
   /** The MPDU is part of an A-MPDU with multiple MPDUs, but is neither the first nor the last aggregate */
   MIDDLE_MPDU_IN_AGGREGATE,
-  /** The MPDU is the last aggregate in an A-MPDU with muliple MPDUs */
+  /** The MPDU is the last aggregate in an A-MPDU with multiple MPDUs */
   LAST_MPDU_IN_AGGREGATE
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-net-device.cc ns-3.31/src/wifi/model/wifi-net-device.cc
--- ns-3.30.1/src/wifi/model/wifi-net-device.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-net-device.cc	2020-06-27 17:38:30.000000000 -0700
@@ -140,9 +140,18 @@
 WifiNetDevice::DoInitialize (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
-  m_phy->Initialize ();
-  m_mac->Initialize ();
-  m_stationManager->Initialize ();
+  if (m_phy)
+    {
+      m_phy->Initialize ();
+    }
+  if (m_mac)
+    {
+      m_mac->Initialize ();
+    }
+  if (m_stationManager)
+    {
+      m_stationManager->Initialize ();
+    }
   NetDevice::DoInitialize ();
 }
 
@@ -349,7 +358,7 @@
 }
 
 void
-WifiNetDevice::ForwardUp (Ptr<Packet> packet, Mac48Address from, Mac48Address to)
+WifiNetDevice::ForwardUp (Ptr<const Packet> packet, Mac48Address from, Mac48Address to)
 {
   NS_LOG_FUNCTION (this << packet << from << to);
   LlcSnapHeader llc;
@@ -371,21 +380,22 @@
       type = NetDevice::PACKET_OTHERHOST;
     }
 
+  Ptr<Packet> copy = packet->Copy ();
   if (type != NetDevice::PACKET_OTHERHOST)
     {
       m_mac->NotifyRx (packet);
-      packet->RemoveHeader (llc);
-      m_forwardUp (this, packet, llc.GetType (), from);
+      copy->RemoveHeader (llc);
+      m_forwardUp (this, copy, llc.GetType (), from);
     }
   else
     {
-      packet->RemoveHeader (llc);
+      copy->RemoveHeader (llc);
     }
 
   if (!m_promiscRx.IsNull ())
     {
-      m_mac->NotifyPromiscRx (packet);
-      m_promiscRx (this, packet, llc.GetType (), from, to, type);
+      m_mac->NotifyPromiscRx (copy);
+      m_promiscRx (this, copy, llc.GetType (), from, to, type);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-net-device.h ns-3.31/src/wifi/model/wifi-net-device.h
--- ns-3.30.1/src/wifi/model/wifi-net-device.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-net-device.h	2020-06-27 17:38:30.000000000 -0700
@@ -63,11 +63,11 @@
   virtual ~WifiNetDevice ();
 
   /**
-   * \param mac the mac layer to use.
+   * \param mac the MAC layer to use.
    */
   void SetMac (const Ptr<WifiMac> mac);
   /**
-   * \param phy the phy layer to use.
+   * \param phy the PHY layer to use.
    */
   void SetPhy (const Ptr<WifiPhy> phy);
   /**
@@ -75,11 +75,11 @@
    */
   void SetRemoteStationManager (const Ptr<WifiRemoteStationManager> manager);
   /**
-   * \returns the mac we are currently using.
+   * \returns the MAC we are currently using.
    */
   Ptr<WifiMac> GetMac (void) const;
   /**
-   * \returns the phy we are currently using.
+   * \returns the PHY we are currently using.
    */
   Ptr<WifiPhy> GetPhy (void) const;
   /**
@@ -146,11 +146,11 @@
    * Receive a packet from the lower layer and pass the
    * packet up the stack.
    *
-   * \param packet
-   * \param from
-   * \param to
+   * \param packet the packet to forward up
+   * \param from the source address
+   * \param to the destination address
    */
-  void ForwardUp (Ptr<Packet> packet, Mac48Address from, Mac48Address to);
+  void ForwardUp (Ptr<const Packet> packet, Mac48Address from, Mac48Address to);
 
 
 private:
@@ -194,7 +194,7 @@
   Ptr<VhtConfiguration> m_vhtConfiguration; //!< the VhtConfiguration
   Ptr<HeConfiguration> m_heConfiguration; //!< the HeConfiguration
   NetDevice::ReceiveCallback m_forwardUp; //!< forward up callback
-  NetDevice::PromiscReceiveCallback m_promiscRx; //!< promiscious receive callback
+  NetDevice::PromiscReceiveCallback m_promiscRx; //!< promiscuous receive callback
 
   TracedCallback<Ptr<const Packet>, Mac48Address> m_rxLogger; //!< receive trace callback
   TracedCallback<Ptr<const Packet>, Mac48Address> m_txLogger; //!< transmit trace callback
